Package: nbpMatching
Type: Package
Title: Functions for Optimal Non-Bipartite Matching
Version: 1.5.6
Date: 2024-09-23
Author: Cole Beck [aut, cre],
  Bo Lu [aut],
  Robert Greevy [aut]
Maintainer: Cole Beck <cole.beck@vumc.org>
Authors@R: c(person("Cole", "Beck", role = c("aut", "cre"),
    email = "cole.beck@vumc.org"),
    person("Bo", "Lu", role = "aut"),
    person("Robert", "Greevy", role = "aut"))
Description: Perform non-bipartite matching and matched randomization. A
    "bipartite" matching utilizes two separate groups, e.g. smokers being
    matched to nonsmokers or cases being matched to controls. A "non-bipartite"
    matching creates mates from one big group, e.g. 100 hospitals being
    randomized for a two-arm cluster randomized trial or 5000 children who
    have been exposed to various levels of secondhand smoke and are being
    paired to form a greater exposure vs. lesser exposure comparison. At the
    core of a non-bipartite matching is a N x N distance matrix for N potential
    mates. The distance between two units expresses a measure of similarity or
    quality as mates (the lower the better). The 'gendistance()' and
    'distancematrix()' functions assist in creating this. The 'nonbimatch()'
    function creates the matching that minimizes the total sum of distances
    between mates; hence, it is referred to as an "optimal" matching. The
    'assign.grp()' function aids in performing a matched randomization. Note
    bipartite matching can be performed using the prevent option in
    'gendistance()'.
License: GPL (>= 2)
Imports: methods, stats, Hmisc, MASS, utils
URL: https://github.com/couthcommander/nbpMatching
Collate: 'distancematrix.R' 'nonbimatch.R' 'assign.grp.R'
        'fill.missing.R' 'gendistance.R' 'make.phantoms.R'
        'nbpmatching-package.R' 'qom.R' 'quantile.R' 'subsetMatches.R'
        'utils.R'
RoxygenNote: 7.3.1
NeedsCompilation: yes
Packaged: 2024-09-24 20:43:47 UTC; beckca
Repository: CRAN
Date/Publication: 2024-09-25 06:50:02 UTC
Built: R 4.6.0; x86_64-apple-darwin20; 2026-04-29 14:43:17 UTC; unix
Archs: nbpMatching.so.dSYM

# Generated by roxygen2: do not edit by hand

exportClasses(distancematrix)
exportClasses(nonbimatch)
exportMethods(assign.grp)
exportMethods(distancematrix)
exportMethods(fill.missing)
exportMethods(full.qom)
exportMethods(gendistance)
exportMethods(get.sets)
exportMethods(make.phantoms)
exportMethods(nonbimatch)
exportMethods(qom)
exportMethods(quantile)
exportMethods(runner)
exportMethods(scalar.dist)
exportMethods(subsetMatches)
import(methods)
import(stats)
importFrom(Hmisc,hdquantile)
importFrom(Hmisc,transcan)
importFrom(MASS,ginv)
importFrom(utils,read.csv)
useDynLib(nbpMatching, .registration = TRUE)

library(nbpMatching)

mdm <- distancematrix('sample_dist_mat.csv')
res <- nonbimatch(mdm)
g1 <- assign.grp(res, seed = 10)
g2 <- assign.grp(res$matches, seed = 10)

expect_equal(dim(g1), c(28, 6))
expect_equal(g1, g2)
expect_equal(g1[1:10,'treatment.grp'], c('A','A','B','B','B','A','B','B','A','A'))

library(nbpMatching)

# need confirmable static Mahal dist matrix

sdm <- read.csv('sample_dist_mat.csv')

set.seed(1)
df <- data.frame(id=LETTERS[1:25], val1=rnorm(25), val2=rnorm(25))
df[sample(seq_len(nrow(df)), ceiling(nrow(df)*0.1)), 2] <- NA
df.dist <- gendistance(df, idcol=1, ndiscard=2)

expect_equal(length(df.dist), 9)
expect_equal(dim(df.dist$dist), c(28, 28))
expect_equal(dim(df.dist$cov), c(25, 3))
expect_equivalent(df.dist$weights, c(1, 1, 0.1))
expect_equal(df.dist$ndiscard, 3)
expect_equal(sum(abs(df.dist$dist-sdm) > 1e-8, na.rm = TRUE), 0)
expect_true(is.infinite(df.dist$dist[1,1]))

df.weighted <- gendistance(df, idcol=1, weights=c(1,2,1), ndiscard=2, missing.weight=0.25)
expect_equal(dim(df.weighted$dist), c(28, 28))
expect_equal(dim(df.weighted$cov), c(25, 3))
#expect_equivalent(df.weighted$weights, c(2, 1, 0.25))
expect_equivalent(df.weighted$weights, c(2, 1, 0.5))
expect_equal(df.weighted$ndiscard, 3)
vals <- c(2.857567, 5.416773, 1.799399, 2.57978)
expect_true(all(abs(unlist(df.weighted$dist[1,2:5])-vals) < 1e-6))
expect_true(all(abs(unlist(df.weighted$dist[2:5,1])-vals) < 1e-6))

df[,3] <- df[,2]*2
expect_warning(df.sing.solve <- gendistance(df, idcol=1, ndiscard=2))
vals <- c(0.6042711, 2.079626, 1.628953, 0.4282725)
expect_true(all(abs(unlist(df.sing.solve$dist[1,2:5])-vals) < 1e-6))
expect_true(all(abs(unlist(df.sing.solve$dist[2:5,1])-vals) < 1e-6))

expect_warning(df.sing.ginv <- gendistance(df, idcol=1, ndiscard=2, singular.method="ginv"))
vals <- c(0.4527432, 1.461176, 1.212691, 0.3519085)
expect_true(all(abs(unlist(df.sing.ginv$dist[1,2:5])-vals) < 1e-6))
expect_true(all(abs(unlist(df.sing.ginv$dist[2:5,1])-vals) < 1e-6))

library(nbpMatching)

set.seed(1)
df <- data.frame(id=LETTERS[1:25], val1=rnorm(25), val2=rnorm(25))
df[sample(seq_len(nrow(df)), ceiling(nrow(df)*0.1)), 2] <- NA
df.dist <- gendistance(df, idcol=1, ndiscard=2)
mdm1 <- distancematrix(df.dist)
mdm2 <- distancematrix(df.dist$dist)
mdm3 <- distancematrix(as.matrix(df.dist$dist))
mdm4 <- distancematrix('sample_dist_mat_wrn.csv', row.names = 1)
mdm5 <- distancematrix('sample_dist_mat.csv')
expect_warning(mdm6 <- distancematrix(matrix(c(0,1,2,1,0,3,2,3,0), 3)))

expect_true(inherits(mdm1, 'distancematrix'))
expect_equal(dim(mdm1), c(28, 28))
expect_equal(mdm1, mdm2)
expect_equal(mdm1, mdm3)
expect_equal(mdm1, mdm4)
expect_equivalent(mdm1, mdm5)
expect_equal(dim(mdm6), c(4, 4))
expect_equal(rownames(mdm6), c(1,2,3,'ghost'))

expect_equal(rownames(distancematrix(matrix(c('A','B',0,1,1,0), 3, byrow = TRUE))), c('A','B'))
expect_equal(rownames(distancematrix(matrix(c('A','B',0,1,1,0), 2))), c('A','B'))
expect_equal(rownames(distancematrix(matrix(c(0,1,1,0), 2))), c('1','2'))

expect_error(distancematrix(df.dist$dist[FALSE,]))
expect_error(distancematrix(df.dist$dist[1:5,]))
expect_error(distancematrix(matrix(c('A','B','C','D'), 2)))
expect_error(distancematrix(matrix(1:4, 2)))
expect_error(distancematrix(list(matrix(c(0,1,1,0), 2))))
expect_error(distancematrix('test_distancematrix.R'))
expect_error(distancematrix('nofile'))
expect_error(mdm5[1,2] <- NA)
expect_error(mdm5[[2]] <- NA)

library(nbpMatching)

mdm <- distancematrix('sample_dist_mat.csv')
res <- nonbimatch(mdm)
expect_equal(length(get.sets(res)), 28)
expect_equal(subsetMatches(res, halvesOnly = TRUE), res$halves)
expect_equal(subsetMatches(res, halvesOnly = FALSE), res$matches)

xx <- scalar.dist(1:3)
expect_equal(xx, matrix(c(0,1,2,1,0,1,2,1,0), 3))

expect_equal(length(quantile(mdm)), 101)

library(nbpMatching)

mdm <- distancematrix('sample_dist_mat.csv')
res <- nonbimatch(mdm)

expect_true(inherits(res, 'nonbimatch'))
expect_equal(length(res), 4)
expect_equal(dim(res$matches), c(28, 5))
expect_equal(dim(res$halves), c(14, 5))
expect_equivalent(res$total, 4.16792951)
expect_equivalent(res$mean, 4.16792951 / 14)

res1 <- nonbimatch(mdm, threshold = 0.5)
expect_warning(res2 <- nonbimatch(mdm, precision = 0))
res3 <- nonbimatch(mdm, precision = 8)
expect_warning(res4 <- nonbimatch(mdm, precision = 10))
expect_equal(grep('chameleon', res1$matches[,1]), 29:34)
expect_equal(res2, res)
expect_equal(res3, res)
expect_equal(res4, res)

set.seed(1)
df <- data.frame(id=LETTERS[1:25], val1=rnorm(25), val2=rnorm(25))
df[sample(seq_len(nrow(df)), ceiling(nrow(df)*0.1)), 2] <- NA
res5 <- runner(df, mate.random = TRUE)
expect_equal(length(res5), 6)
expect_equal(length(full.qom(df)), 6)

qm <- qom(res5$setup$cov, res5$matches$matches, use.se = TRUE, all.vals = TRUE)
expect_equal(length(qm), 3)
